#include <States/GameState/Context/ContextManager.h>

void ContextManager::reset(GameContext&& context) {
    while (!m_contexts.empty())
        m_contexts.pop();
    m_initial_context = std::move(context);
    m_contexts.emplace(m_initial_context.clone());
}

void ContextManager::save_context() {
    m_contexts.emplace(m_contexts.top().clone());
}

void ContextManager::restore_previous_context() {
    if (m_contexts.size() > 1) {
        const size_t defeat_count = m_contexts.top().defeats_count;
        m_contexts.pop();
        m_contexts.top().defeats_count = defeat_count;
    }
    else
        m_contexts.top() = m_initial_context.clone();
}