#include <States/GameState/Entities/StaticEntities/StaticEntities.h>
#include <Configuration.h>
#include <BasicAbstractions/Assets.h>
#include <Themes/Themes.h>

Food::Food() : m_rect({ config::GAME_FOOD_SIZE, config::GAME_FOOD_SIZE }) {
    m_rect.setOrigin({config::GAME_FOOD_SIZE, config::GAME_FOOD_SIZE});
    m_rect.setTexture(&Assets::GetFoodTexture());
}

std::unique_ptr<IStaticEntity> Food::clone() const {
    return std::make_unique<Food>(*this);
}

void Food::draw_into(sf::RenderWindow& window) const {
    window.draw(m_rect);
}

void Food::prepare_for_first_drawing() {
    prepare_for_drawing();
}

void Food::prepare_for_drawing() {
    m_rect.setPosition(m_ptr_room->get_position());
}