#pragma once
#include <BasicAbstractions/IDrawable.h>
#include <States/GameState/Maze/Room/RoomSide/RoomSide.h>
#include <array>

struct IRoomSide;

class Room final : public IDrawable {
public:
    enum Direction { INVALID = -1, LEFT, RIGHT, UP, DOWN };
    explicit Room(float size);
    float get_size() const noexcept { return m_rectangle.getSize().x; }
    void set_position(const sf::Vector2f pos) { m_rectangle.setPosition(pos); }
    void set_color(const sf::Color color) { m_rectangle.setFillColor(color); }
    sf::Vector2f get_position() const noexcept { return m_rectangle.getPosition(); }
    void set_side(Direction side, const std::shared_ptr<IRoomSide>& ptr_side);
    IRoomSide* get_side(const Direction side) const noexcept { return m_sides[side].get(); }
    Direction get_direction(const IRoomSide* ptr_side) const;
    void draw_into(sf::RenderWindow& window) const override;
private:
    sf::RectangleShape m_rectangle;
    std::array<std::shared_ptr<IRoomSide>, 4> m_sides;
};