#include <States/SelectState/SelectState.h>
#include <States/ChangeStateCommand.h>
#include <States/GameState/GameBuilder/GameBuilderDirector.h>
#include <Themes/Themes.h>

void SelectState::event_handling() {
    sf::Event event{};
    while (m_window.pollEvent(event)) {
        if (event.type == sf::Event::Closed) {
            m_state_manager.set_next_state(std::make_unique<ExitState>(m_state_manager));
        }
        if (event.type == sf::Event::Resized) {
            sf::View view = m_window.getView();
            view.setSize(static_cast<float>(event.size.width), static_cast<float>(event.size.height));
            m_window.setView(view);
        }
    }
}

void SelectState::update() {
    m_menu.process_mouse(m_window.mapPixelToCoords(sf::Mouse::getPosition(m_window)),
        sf::Mouse::isButtonPressed(sf::Mouse::Left));
}

void SelectState::render() {
    m_window.clear(Themes::Instance().get_select_level_background_color());
    m_menu.draw_into(m_window);
    m_window.display();
}

bool SelectState::do_step() {
    event_handling();
    update();
    render();
    return true;
}